> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# Get the SQL query for a report element

GET https://api.sigmacomputing.com/v2/reports/{reportId}/elements/{elementId}/query

This endpoint retrieves the SQL query associated with a specific element in a report. It allows users to view and understand how the data for that element is being processed and transformed.

### Usage notes
- Retrieve the **reportId** by calling the [/v2/reports](https://help.sigmacomputing.com/reference/list-reports) endpoint.
- Retrieve the **elementId** by first calling the [/v2/reports/{reportId}/pages](listreportpages) endpoint, then calling the [/v2/reports/{reportId}/pages/{pageId}/elements](listreportpageelements) endpoint.

### Usage scenarios
- **Development and debugging:** Provides developers and analysts with the ability to retrieve and review the SQL code behind report elements, facilitating troubleshooting and enhancements.
- **Educational insight:** Useful for training purposes or for users learning to understand the impact of various transformations and filters applied within their reports.

### Best practices
- Ensure proper access controls are in place to manage who can view potentially sensitive query information.
- Use this endpoint as part of a regular review process to ensure that all queries are optimized and up to date with current data schemas.

Reference: https://help.sigmacomputing.com/reference/get-report-element-query

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/reports/{reportId}/elements/{elementId}/query:
    get:
      operationId: getReportElementQuery
      summary: Get the SQL query for a report element
      description: >-
        This endpoint retrieves the SQL query associated with a specific element
        in a report. It allows users to view and understand how the data for
        that element is being processed and transformed.


        ### Usage notes

        - Retrieve the **reportId** by calling the
        [/v2/reports](https://help.sigmacomputing.com/reference/list-reports)
        endpoint.

        - Retrieve the **elementId** by first calling the
        [/v2/reports/{reportId}/pages](listreportpages) endpoint, then calling
        the
        [/v2/reports/{reportId}/pages/{pageId}/elements](listreportpageelements)
        endpoint.


        ### Usage scenarios

        - **Development and debugging:** Provides developers and analysts with
        the ability to retrieve and review the SQL code behind report elements,
        facilitating troubleshooting and enhancements.

        - **Educational insight:** Useful for training purposes or for users
        learning to understand the impact of various transformations and filters
        applied within their reports.


        ### Best practices

        - Ensure proper access controls are in place to manage who can view
        potentially sensitive query information.

        - Use this endpoint as part of a regular review process to ensure that
        all queries are optimized and up to date with current data schemas.
      tags:
        - Reports
      parameters:
        - name: reportId
          in: path
          required: true
          schema:
            type: string
        - name: elementId
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/reports_getReportElementQuery_Response_200
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    reports_getReportElementQuery_Response_200:
      type: object
      properties:
        elementId:
          type: string
        name:
          type: string
        sql:
          type: string
        error:
          type: string
      required:
        - elementId
      title: reports_getReportElementQuery_Response_200
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples



**Response**

```json
{
  "elementId": "string",
  "name": "string",
  "sql": "string",
  "error": "string"
}
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/reports/reportId/elements/elementId/query"

headers = {"Authorization": "<token>."}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/reports/reportId/elements/elementId/query';
const options = {method: 'GET', headers: {Authorization: '<token>.'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/reports/reportId/elements/elementId/query"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "<token>.")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/reports/reportId/elements/elementId/query")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = '<token>.'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.sigmacomputing.com/v2/reports/reportId/elements/elementId/query")
  .header("Authorization", "<token>.")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.sigmacomputing.com/v2/reports/reportId/elements/elementId/query', [
  'headers' => [
    'Authorization' => '<token>.',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/reports/reportId/elements/elementId/query");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "<token>.");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "<token>."]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/reports/reportId/elements/elementId/query")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```